﻿WFCDThand = nil
--WFCDTdefault = nil
function WFCDTLoadOptions()
    WFCDTvalues = {}    --need to write the graph loader before i can delete self
    if (WFCDTdefault==nil) or (WFCDTdefault.version < 10020) then
        WFCDTdefault = {
            --misc
            ["debug"]            = 0,
            ["name"]            = "WFCDT",
            ["author"]            = "Mahiro/Grognaz - Aegwynn(EU)",
            ["version"]            = 10020,
            
            --main
            ["WFcount"]            = 0,
            ["WFstart"]            = 0,
            ["WFstop"]            = 0,
            ["WFlast"]            = nil,
            ["WFbest"]            = nil,
            ["WFmain"]            = nil,
            ["WFoff"]            = nil,
            ["info"]            = 1,
            ["point"]            = "CENTER",
            ["rpoint"]            = "CENTER",
            ["xpos"]            = 0,
            ["ypos"]            = 0,
            ["lock"]            = 0,
            ["scale"]            = 0.8,
            
            --damage from wf hits
            ["dmg"]             = 0,
            ["dmgsum"]             = 0,
            ["dmgrecord"]         = 0,    
            ["mh"]                = 0,
            ["oh"]                = 0,
            
            --graph
            ["number"]             = 0,
            ["maxbars"]            = 70,            
            ["gpoint"]            = "CENTER",
            ["grpoint"]            = "CENTER",
            ["gxpos"]            = 0,
            ["gypos"]            = 0,
            
        }
    else 
        WFCDTdefault=WFCDTdefault
    end
end

--load
function WFCDTFrameOnLoad(self, event)
    
    SLASH_WFCDT1 = "/WFCDT"
    SlashCmdList["WFCDT"] = WFCDTCommand

    self:RegisterEvent("ADDON_LOADED")
    self:RegisterEvent("PLAYER_TARGET_CHANGED")
    self:RegisterEvent("COMBAT_LOG_EVENT")

end

--commands
function WFCDTCommand(cmd)
    if (cmd=="") then
        DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.name.." - "..WFCDTdefault.version.." - "..WFCDTdefault.author)
        DEFAULT_CHAT_FRAME:AddMessage("/WFCDT reset - reset values")
        DEFAULT_CHAT_FRAME:AddMessage("/WFCDT lock - lock frame")
        DEFAULT_CHAT_FRAME:AddMessage("/WFCDT info - show/hide details")
        DEFAULT_CHAT_FRAME:AddMessage("/WFCDT center - reset frame position")
        DEFAULT_CHAT_FRAME:AddMessage("/WFCDT standby - nothing yet")
        DEFAULT_CHAT_FRAME:AddMessage("/WFCDT debug - enable/disable debug mode")
    end
    
    if (cmd=="reset") then
        WFCDTResetOnClick()
    end

    if (cmd=="lock") then
        WFCDTLockOnClick()
    end
    
    if (cmd=="info") then
        WFCDTInfoOnClick()
    end
    
    if (cmd=="debug") then
        if WFCDTdefault.debug==1 then
            WFCDTdefault.debug = 0
            DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.name.." - ".."debugging disabled")
        else
            WFCDTdefault.debug = 1
            DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.name.." - ".."debugging enabled")
        end
    end
        
    if (cmd=="center") then
        WFCDTdefault.point = "CENTER"
        WFCDTdefault.xpos = 0 
        WFCDTdefault.ypos = 0
        WFCDTBar:ClearAllPoints() 
        WFCDTBar:SetPoint(WFCDTdefault.point, nil, WFCDTdefault.point, WFCDTdefault.xpos, WFCDTdefault.ypos)
    
        WFCDTdefault.gpoint = "CENTER"
        WFCDTdefault.gxpos = 0 
        WFCDTdefault.gypos = 0
        WFCDTGraph:ClearAllPoints() 
        WFCDTGraph:SetPoint(WFCDTdefault.gpoint, nil, WFCDTdefault.gpoint, WFCDTdefault.gxpos, WFCDTdefault.gypos)
    end

    if (cmd=="standby") then
        
    end    
    
end

--event
function WFCDTCheckOnEvent(self, event, ...)
    if (event=="ADDON_LOADED") then
        WFCDTLoadOptions()
        WFCDTdefault.WFcount=0
        WFCDTdefault.WFstart=0
        WFCDTdefault.WFstop=0
        WFCDToutput()
        WFCDTResetBar()
        WFCDTPosition()
        
        if (WFCDTdefault.info==1) then
            WFCDTFrame:Show()
            WFCDTInfo:SetText("-")
        elseif (WFCDTdefault.info==0) then
            WFCDTFrame:Hide()
            WFCDTInfo:SetText("+")
        end
        
        --here the font color, size and flags are loaded
        local font,size,flag = "FRIZQT__.TTF",10,"OUTLINE"
        local r,g,b,a = 1,1,1,1
        WFCDTTimeBar:SetTexture("Interface\\AddOns\\WFCDT\\bar_w")
        WFCDTTimeBarText:SetFont(font,size,flag)
        WFCDTTimeBarText:SetTextColor(r,g,b,a)
                
        WFCDTSpeed:SetFont(font,size,flag)
        WFCDTSpeed:SetTextColor(r,g,b,a)
        
        WFCDTLast:SetFont(font,size,flag)
        WFCDTLast:SetTextColor(r,g,b,a)
        
        WFCDTCurrent:SetFont(font,size,flag)
        WFCDTCurrent:SetTextColor(r,g,b,a)
        
        WFCDTDmg:SetFont(font,size,flag)
        WFCDTDmg:SetTextColor(r,g,b,a)
        
        
        WFCDTBest:SetFont(font,size,flag)
        WFCDTBest:SetTextColor(1, 1, 0, 1)
        
        WFCDTTimeRecord:SetFont(font,size,flag)
        WFCDTTimeRecord:SetTextColor(1, 1, 0, 1)
        
        WFCDTGraphStatus:SetFont(font,size,flag)
        WFCDTGraphStatus:SetTextColor(1, 1, 0, 1)
        
        WFCDTMh:SetFont(font,size,flag)
        WFCDTMh:SetTextColor(0, 1, 0, 1)
        
        WFCDTOh:SetFont(font,size,flag)
        WFCDTOh:SetTextColor(1,0.5,0, 1)
        
        
        
        WFCDTBar:SetScale(WFCDTdefault.scale)
        WFCDTGraph:SetScale(WFCDTdefault.scale)
        
        WFCDTBar:SetClampedToScreen( true )
        WFCDTGraph:SetClampedToScreen( true )
        
        WFCDTLoadGraph()
    end    

    if (event=="PLAYER_TARGET_CHANGED") then 
        WFCDTdefault.WFcount=0
        WFCDTdefault.WFstart=0
        WFCDTdefault.WFstop=0
        WFCDTResetBar()
    end
end

--update
function WFCDTOnUpdate(self, elapsed)
    if (WFCDTdefault.WFstart>0) then
        WFCDTCurrent:SetText("elapsed: "..string.format("%.2f", GetTime()-WFCDTdefault.WFstart).."s")
    else 
        WFCDTCurrent:SetText("elapsed: "..string.format("%.2f", WFCDTdefault.WFstart).."s")
    end
    WFCDTBestBar()
end


function windfuryProc(amount, spellId)
    local count = WFCDTdefault.WFcount
    local damage = WFCDTdefault.dmg
    local max = 3
    
    if count < max then
        --stop timer and write time if shorter
        if count == 0 then
            WFCDTdefault.WFstop = GetTime()
            WFCDTRecord()
            damage = 0
        end        
        damage = damage + amount
        WFCDTdefault.dmg = damage        
        count = count + 1
        WFCDTdefault.WFcount = count
        --DEFAULT_CHAT_FRAME:AddMessage("count: "..count.." - ".. damage)   
        
        --write output and reset if wf count is reached
        if count == 3 then
            --DEFAULT_CHAT_FRAME:AddMessage("sum: "..count.." - ".. damage)
            UIErrorsFrame:AddMessage("WF: "..damage, 0, 1, 0, 53, 5)
            if (damage) > (WFCDTdefault.dmgrecord) then
                WFCDTdefault.dmgrecord = damage
                UIErrorsFrame:AddMessage("New WF record! " ..damage, 1, 1, 0, 53, 10)
            end    
            WFCDTdefault.dmgsum = damage          
            WFCDToutput()
            
            --create graph
            if spellId == 25504 then 
                WFCDThand=1
                WFCDTCreateGraph(WFCDThand)
                WFCDTdefault.mh = WFCDTdefault.mh+1
            else 
                WFCDThand=0
                WFCDTCreateGraph(WFCDThand)
                WFCDTdefault.oh = WFCDTdefault.oh+1
            end

            WFCDTdefault.dmg = 0
            WFCDTdefault.WFcount = 0          
            WFCDTdefault.WFstart=GetTime()
        end
    end
end

function flameProc(amount, spellId)
    WFCDTdefault.dmgsum = amount          
    WFCDToutput()
    WFCDThand=2
    WFCDTCreateGraph(WFCDThand)
    WFCDTdefault.oh = WFCDTdefault.oh+1
end

function frostProc(amount, spellId)
    WFCDTdefault.dmgsum = amount          
    WFCDToutput()
    WFCDThand=3
    WFCDTCreateGraph(WFCDThand)
    WFCDTdefault.oh = WFCDTdefault.oh+1
end

function shieldProcProc(amount, spellId)
    WFCDTdefault.dmgsum = amount          
    WFCDToutput()
    WFCDThand=4
    WFCDTCreateGraph(WFCDThand)
    --WFCDTdefault.oh = WFCDTdefault.oh+1
end

function spellParser(spellId, spellName, amount)
    DEFAULT_CHAT_FRAME:AddMessage(spellName.."(ID: "..spellId .. ") dmg: "..amount)
end

function WFCDTParseGained(self, event, ...)
    --figure out what we have done here exactly     http://www.wowwiki.com/API_select
    local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
    if (event=="COMBAT_LOG_EVENT") and (type=="SPELL_DAMAGE") then   
        local spellId, spellName, spellSchool = select(12, ...)   
        local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(15, ...)
        
        --spellParser(spellId, spellName, amount)
        --windfury mainhand(spellid MH:25504)
        if (spellId==25504) then
            windfuryProc(amount, spellId)             
        --Windfury offhand (spellid 33750)
        elseif (spellId==33750) then
            windfuryProc(amount, spellId)             
        --Flametongue (spellid 10444)
        elseif (spellId==10444) then
            flameProc(amount, spellId)          
        --Frostbrand (spellid 25501)
        elseif (spellId==8034) then
            frostProc(amount, spellId)           
        --lightning shield (spellid 26364)
        elseif (spellId==26364) then
            shieldProcProc(amount, spellId)
        end
    end
end


--bar
function WFCDTBestBar()
    local r,g,b,a

    if not (WFCDTdefault.WFbest==nil) then
        if ((GetTime()-WFCDTdefault.WFstart)<WFCDTdefault.WFbest) then
            r,g,b,a=1,0,0,1
        elseif ((GetTime()-WFCDTdefault.WFstart)>=WFCDTdefault.WFbest) then
            r,g,b,a=0,1,0,1
        end
    
        local width = (WFCDTBar:GetWidth()/WFCDTdefault.WFbest*(GetTime()-WFCDTdefault.WFstart))
        local offset = 6
        WFCDTTimeBar:SetVertexColor(r,g,b,a)
        WFCDTTimeBar:SetHeight(WFCDTBar:GetHeight()-offset)
        
        if (WFCDTdefault.WFstart>0) and ((GetTime()-WFCDTdefault.WFstart)<=WFCDTdefault.WFbest) then
            WFCDTTimeBar:SetWidth(width-offset)
        elseif (WFCDTdefault.WFstart>0) and ((GetTime()-WFCDTdefault.WFstart)>=WFCDTdefault.WFbest) then
            WFCDTTimeBar:SetWidth(WFCDTBar:GetWidth()-offset)
        end    
    else 
        WFCDTResetBar()
    end
end

function WFCDTResetBar()
    local offset = 6
    local r,g,b,a = 0,1,0,0.5
    WFCDTTimeBar:SetWidth(WFCDTBar:GetWidth()-offset)
    WFCDTTimeBar:SetHeight(WFCDTBar:GetHeight()-offset)
    WFCDTTimeBar:SetVertexColor(r,g,b,a)
end

function WFCDTRecord()
    if (WFCDTdefault.WFstart~=0) then
        WFCDTdefault.WFlast=(WFCDTdefault.WFstop-WFCDTdefault.WFstart)
        --WFCDTLast:SetText("Last: "..string.format("%.2f", WFCDTdefault.WFlast).."s")
    end
    
    if (WFCDTdefault.WFbest==nil) then
        if (WFCDTdefault.WFlast~=nil) then
            WFCDTdefault.WFbest=WFCDTdefault.WFlast
            WFCDTBest:SetText("Best: "..string.format("%.2f", WFCDTdefault.WFbest).."s")
            WFCDToutput()
        end
    else
        if (WFCDTdefault.WFlast~=nil) and (WFCDTdefault.WFlast<WFCDTdefault.WFbest) then
            local mainSpeed, offSpeed = UnitAttackSpeed("player")
            WFCDTdefault.WFmain = mainSpeed
            WFCDTdefault.WFoff = offSpeed
            WFCDTdefault.WFbest=WFCDTdefault.WFlast
            WFCDTBest:SetText("Best: "..string.format("%.2f", WFCDTdefault.WFbest).."s")
            WFCDToutput()
        else
            WFCDToutput()
        end
    end
end

function WFCDToutput()
    WFCDTGraphStatus:SetText(WFCDTdefault.dmgrecord) --self should display the number of bars as well
    
    if (WFCDTdefault.WFbest~=nil) then
        WFCDTBest:SetText("Best: "..string.format("%.2f", WFCDTdefault.WFbest).."s")
    else
        WFCDTBest:SetText("Best: none")
    end    
    
    WFCDTTimeRecord:SetText("Best WF: "..WFCDTdefault.dmgrecord)
    
    local mhpercent = string.format("%.0f", 100/(WFCDTdefault.mh+WFCDTdefault.oh)*WFCDTdefault.mh)
    local ohpercent = string.format("%.0f", 100/(WFCDTdefault.mh+WFCDTdefault.oh)*WFCDTdefault.oh)
    WFCDTMh:SetText("Mh: "..WFCDTdefault.mh.." ("..mhpercent.."%)")
    WFCDTOh:SetText("Oh: "..WFCDTdefault.oh.." ("..ohpercent.."%)")
    
    if (WFCDTdefault.WFlast~=nil) then    
        WFCDTLast:SetText("Last: "..string.format("%.2f", WFCDTdefault.WFlast).."s")
    else
        WFCDTLast:SetText("Last: none")
    end    
    
    WFCDTDmg:SetText("Last WF: "..WFCDTdefault.dmgsum)
    
    if (WFCDTdefault.WFstart~=0) then
        WFCDTCurrent:SetText("self: "..string.format("%.2f", GetTime()-WFCDTdefault.WFstart).."s")
    else 
        WFCDTCurrent:SetText("self: "..string.format("%.2f", WFCDTdefault.WFstart).."s")
    end
    
    if (WFCDTdefault.info==0) then
        if (WFCDTdefault.WFbest~=nil) and (WFCDTdefault.WFmain~=nil) and (WFCDTdefault.WFoff~=nil) then
            WFCDTTimeBarText:SetText(string.format("%.2f", WFCDTdefault.WFbest).."s/"..string.format("%.2f", WFCDTdefault.WFmain).."/"..string.format("%.2f", WFCDTdefault.WFoff))
        else 
            WFCDTTimeBarText:SetText("WFCDT")
        end
    
    elseif (WFCDTdefault.info==1) then        
        WFCDTTimeBarText:SetText("WFCDT")
        if (WFCDTdefault.WFmain~=nil) and (WFCDTdefault.WFoff~=nil) then
            WFCDTSpeed:SetText("Speed: "..string.format("%.2f", WFCDTdefault.WFmain).." / "..string.format("%.2f", WFCDTdefault.WFoff))
        else
            WFCDTSpeed:SetText("Speed: -/-")
        end        
    end
end

function WFCDTInfoOnClick()
    if WFCDTFrame:IsVisible(true) then 
        WFCDTdefault.info=0
        WFCDTFrame:Hide()
        WFCDTInfo:SetText("+")
    else
        WFCDTdefault.info=1
        WFCDTFrame:Show()
        WFCDTInfo:SetText("-")
    end
    WFCDToutput()
end

function WFCDTResetOnClick()
    --best, last wf, mh, oh count and of corse the bars?
    WFCDTdefault.dmgrecord = 0
    WFCDTdefault.dmgsum = 0
    WFCDTdefault.mh    = 0
    WFCDTdefault.oh = 0
    WFCDTdefault.WFbest=nil
    WFCDTdefault.WFmain=nil
    WFCDTdefault.WFoff=nil
    WFCDTdefault.WFlast=nil
    WFCDTdefault.WFcount=0
    WFCDTdefault.WFstart=0
    WFCDTdefault.WFstop=0
     WFCDToutput()
    DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.name.." - reseted")
end

function WFCDTShowGraphOnClick()
    if (WFCDTGraph:IsVisible()) then
        WFCDTGraph:Hide()
    else 
        WFCDTGraph:Show()        
        WFCDTResizeGraph()
        --WFCDT:CreateGraph()
    end
end

function WFCDTSetPosition()
    local point, relativeTo, relativePoint, xOfs, yOfs = WFCDTBar:GetPoint()
    WFCDTdefault.point=point
    WFCDTdefault.rpoint=relativePoint
    WFCDTdefault.xpos=xOfs
    WFCDTdefault.ypos=yOfs
    if WFCDTdefault.debug == 1 then
        DEFAULT_CHAT_FRAME:AddMessage(point..":"..xOfs..":"..yOfs)
        DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.point..":"..WFCDTdefault.xpos..":"..WFCDTdefault.ypos)
    end
    
    local gpoint, grelativeTo, grelativePoint, gxOfs, gyOfs = WFCDTGraph:GetPoint()
    WFCDTdefault.gpoint=gpoint
    WFCDTdefault.grpoint=grelativePoint
    WFCDTdefault.gxpos=gxOfs
    WFCDTdefault.gypos=gyOfs
    if WFCDTdefault.debug == 1 then
        DEFAULT_CHAT_FRAME:AddMessage(gpoint..":"..gxOfs..":"..gyOfs)
        DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.gpoint..":"..WFCDTdefault.gxpos..":"..WFCDTdefault.gypos)
    end
end
                
function WFCDTLockOnClick()
    local point, relativeTo, relativePoint, xOfs, yOfs = WFCDTBar:GetPoint()
    local gpoint, grelativeTo, grelativePoint, gxOfs, gyOfs = WFCDTGraph:GetPoint()
    if (WFCDTBar:IsMovable(true)) then
        WFCDTdefault.lock=1
        WFCDTSetPosition()
        
        WFCDTBar:SetMovable(false)
        WFCDTBar:EnableMouse(false)
        WFCDTGraph:SetMovable(false)
        WFCDTGraph:EnableMouse(false)        
        DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.name.." - locked")        
    else
        WFCDTdefault.lock=0
        WFCDTBar:ClearAllPoints() 
        WFCDTBar:SetMovable(true)
        WFCDTBar:EnableMouse(true)
        
        WFCDTGraph:ClearAllPoints() 
        WFCDTGraph:SetMovable(true)
        WFCDTGraph:EnableMouse(true)
        DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.name.." - unlocked")
    end
end

function WFCDTPosition()
    if WFCDTdefault.debug == 1 then
        DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.point..":"..WFCDTdefault.xpos..":"..WFCDTdefault.ypos)
        DEFAULT_CHAT_FRAME:AddMessage(WFCDTdefault.gpoint..":"..WFCDTdefault.gxpos..":"..WFCDTdefault.gypos)
    end
    if (WFCDTdefault.lock==1) then
        WFCDTBar:ClearAllPoints() 
        WFCDTBar:SetPoint(WFCDTdefault.point, WFCDTdefault.relativePoint, WFCDTdefault.xpos, WFCDTdefault.ypos)
        WFCDTBar:SetMovable(false)
        WFCDTBar:EnableMouse(false)
        
        WFCDTGraph:ClearAllPoints() 
        WFCDTGraph:SetPoint(WFCDTdefault.gpoint, WFCDTdefault.grelativePoint, WFCDTdefault.grpoint, WFCDTdefault.gxpos, WFCDTdefault.gypos)
        WFCDTGraph:SetMovable(false)
        WFCDTGraph:EnableMouse(false)
        
    elseif (WFCDTdefault.lock==0) then
        WFCDTBar:ClearAllPoints() 
        WFCDTBar:SetPoint(WFCDTdefault.point, WFCDTdefault.relativePoint, WFCDTdefault.rpoint, WFCDTdefault.xpos, WFCDTdefault.ypos)
        WFCDTBar:SetMovable(true)
        WFCDTBar:EnableMouse(true)
        
        WFCDTGraph:ClearAllPoints() 
        WFCDTGraph:SetPoint(WFCDTdefault.gpoint, WFCDTdefault.grelativePoint, WFCDTdefault.gxpos, WFCDTdefault.gypos)
        WFCDTGraph:SetMovable(true)
        WFCDTGraph:EnableMouse(true)
    end
end

function WFCDTGraphPlusOnClick()
    local bars = 0
    if (bars < WFCDTdefault.maxbars) then
        bars = bars + 1
        WFCDTGraphStatus:SetText("Bars: "..bars)
        --resize the width of the bars
        --[[
        
        for i=1,WFCDTdefault.number do
            if (WFCDTvalues) then
                if (WFCDTvalues[tostring(i)]~=nil) then
                    local anchor = getglobal(WFCDTvalues[tostring(i)]["1"])
                    local layer = getglobal(WFCDTvalues[tostring(i)]["2"])
                    local width = (WFCDTGraph:GetWidth()-10)/WFCDTdefault.number
                    
                    DEFAULT_CHAT_FRAME:AddMessage("increase bar: "..tostring(anchor).." - "..tostring(layer))
                    DEFAULT_CHAT_FRAME:AddMessage("increase number: "..WFCDTdefault.number)
            
                    anchor:Show()
                    layer:Show()
                    anchor:SetWidth(width)
                    layer:SetWidth(width)
                end
            end
        end
        --]]
    end
end

function WFCDTGraphMinusOnClick()
    if (WFCDTdefault.maxbars>5) then
        if (WFCDTdefault.number~=nil) then
            if (WFCDTdefault.maxbars > WFCDTdefault.number) then
                --self only reduces the maxbars not the frames or anything else
                WFCDTdefault.maxbars=WFCDTdefault.maxbars-1
                WFCDTGraphStatus:SetText("Bars: "..WFCDTdefault.maxbars)
            elseif (WFCDTdefault.maxbars == WFCDTdefault.number) and (WFCDTdefault.number>5) then
                --we dont want the last index get a nil value so we only go to WFCDTdefault.number-1
                local buffer = WFCDTdefault.number
                for i=1,WFCDTdefault.number-1 do
                    --first we need to pass the dmg to the lower indexed entrys
                    WFCDTvalues[tostring(i)]["3"] = WFCDTvalues[tostring(i+1)]["3"]
                    --then we need the color and the height for those layers
                    local colorlayer = getglobal(WFCDTvalues[tostring(i+1)]["2"])
                    local r,g,b,a = colorlayer:GetVertexColor()
                    local layer = getglobal(WFCDTvalues[tostring(i)]["2"])
                    local height = (WFCDTGraph:GetHeight()-10)/WFCDTdefault.dmgrecord*WFCDTvalues[tostring(i)]["3"]
                    layer:SetHeight(height)
                    layer:SetVertexColor(r,g,b,a)
                    
                    if (i==WFCDTdefault.number-1 ) then
                        --after that we hide the last frame and remove the table entry
                        local anchor = getglobal(WFCDTvalues[tostring(WFCDTdefault.number)]["1"])
                        local layer = getglobal(WFCDTvalues[tostring(WFCDTdefault.number)]["2"])
                        anchor:Hide()
                        layer:Hide()
                        --now we can reduce the number by one and update the graph
                        WFCDTdefault.number=WFCDTdefault.number-1
                        WFCDTdefault.maxbars=WFCDTdefault.maxbars-1
                        WFCDTGraphStatus:SetText("Bars: "..WFCDTdefault.maxbars)
                    end
                    WFCDTResizeGraph()
                end    
            end
        end
    end
end

function WFCDTGraphOnClick()
    if (WFCDTGraph:IsVisible()) then
        WFCDTGraph:Hide()
    end
end

function WFCDTGraphScaleOnClick()
     WFCDTLoadGraph()
end