﻿WFCDT = {}

local function barColor()
    if (WFCDThand==0) then          -- windfury mh
        r,g,b,a = 1, 0.5, 0, 1
    elseif (WFCDThand==1) then      -- windfury oh
        r,g,b,a = 0, 1, 0, 1
    elseif (WFCDThand==2) then      -- flamethoinonge
        r,g,b,a = 1, 0, 0, 1
    elseif (WFCDThand==3) then      -- frostbrand
        r,g,b,a = 0, 0, 1, 1
    elseif (WFCDThand==4) then      -- lightning shield
        r,g,b,a = 1, 1, 1, 1
    end
   return r,g,b,a 
end

function WFCDT:FrameCreator(framename,parent,point,rpoint,posx,posy,height,width,r,g,b,a)
    local frame
    local value = {}
    local texture = "Interface\\AddOns\\WFCDT\\bar_h"
    --create anchor
    frame = CreateFrame("Frame", framename.."Anchor", parent)
    frame:ClearAllPoints()
    frame:SetHeight(height)
    frame:SetWidth(width)
    frame:SetPoint(point,parent,rpoint, posx, posy)
    --frame:Show()
    value["anchor"] = frame
    --create first layer
    frame = value["anchor"]:CreateTexture(framename.."Layer", "BACKGROUND")
    frame:ClearAllPoints()
    frame:SetHeight(height)
    frame:SetWidth(width)
    frame:SetPoint("BOTTOM",framename.."Anchor","BOTTOM")
    --frame:Show()
    frame:SetTexture(texture)
    frame:SetVertexColor(r,g,b,a)
    value["layer"] = frame
end

function WFCDT:CreateGraph()
    local width =  300
    local height = 140
    local r,g,b,a = barColor()
    --(framename,parent,point,rpoint,posx,posy,height,width,r,g,b,a)
    self.graph = self:FrameCreator("graph"..WFCDTdefault.number ,WFCDTFrame, "BOTTOMLEFT", "BOTTOMLEFT", 5, 4, height, width, r,g,b,a)
    
end


function WFCDT:CreateBar()
    --framename,parent,point,rpoint,posx,posy,height,width,r,g,b
    local width = (WFCDTGraph:GetWidth()-10)/WFCDTdefault.number
    local height = (WFCDTGraph:GetHeight()-10)/WFCDTdefault.dmgrecord*WFCDTdefault.dmgsum
    local r,g,b,a = barColor()
    
    --create anchor
    if (WFCDTdefault.number==1) then
            --DEFAULT_CHAT_FRAME:AddMessage("anchor: "..WFCDTdefault.number)
        self.bar = self:FrameCreator("bar"..WFCDTdefault.number ,WFCDTGraph, "BOTTOMLEFT", "BOTTOMLEFT", 5, 4, height, width, r,g,b,a)
        WFCDTvalues[tostring(WFCDTdefault.number)]["1"] = tostring("bar"..WFCDTdefault.number.."Anchor")
        WFCDTvalues[tostring(WFCDTdefault.number)]["2"] = tostring("bar"..WFCDTdefault.number.."Layer")
    elseif (WFCDTdefault.number<=WFCDTdefault.maxbars) then    --create layers (33max)
            --DEFAULT_CHAT_FRAME:AddMessage("layer: "..WFCDTdefault.number)
        local parent = getglobal(WFCDTvalues[tostring(WFCDTdefault.number-1)]["1"])
        self.bar = self:FrameCreator("bar"..WFCDTdefault.number, parent ,"BOTTOMLEFT","BOTTOMRIGHT", 0, 0, height, width, r,g,b,a)
        WFCDTvalues[tostring(WFCDTdefault.number)]["1"] = tostring("bar"..WFCDTdefault.number.."Anchor")
        WFCDTvalues[tostring(WFCDTdefault.number)]["2"] = tostring("bar"..WFCDTdefault.number.."Layer")
    end                
end

function WFCDTCreateGraph()
    --create the first bar
    if (WFCDTvalues==nil) then    
        WFCDTvalues= {}
    end
    if (WFCDTvalues["1"]==nil) then
        WFCDTdefault.number = 1
        WFCDTvalues["1"]={["1"]={--[[anchor--]]},["2"]={--[[layer--]]},["3"]={--[[dmg--]]},}
        WFCDTvalues["1"]["3"] = WFCDTdefault.dmgsum
            --DEFAULT_CHAT_FRAME:AddMessage("create: "..WFCDTdefault.number)    
        --dont create if it already exist(we dont get the problem here because we never hide this bar
        WFCDT:CreateBar()
        
    --move those bars when end is reached
    elseif (WFCDTdefault.number==WFCDTdefault.maxbars) then    
        for i=1,WFCDTdefault.number-1 do
            --transfer data
            WFCDTvalues[tostring(i)]["3"] = WFCDTvalues[tostring(i+1)]["3"]
            --get the color
            local colorlayer = getglobal(WFCDTvalues[tostring(i+1)]["2"])
            local r,g,b,a = colorlayer:GetVertexColor()
            --set new height
            local layer = getglobal(WFCDTvalues[tostring(i)]["2"])
            local height = (WFCDTGraph:GetHeight()-10)/WFCDTdefault.dmgrecord*WFCDTvalues[tostring(i)]["3"]
            layer:SetHeight(height)
            --set the color
            layer:SetVertexColor(r,g,b,a)
            if (i==WFCDTdefault.number-1) then
                --set new dmg
                WFCDTvalues[tostring(WFCDTdefault.number)]["3"]= WFCDTdefault.dmgsum
                --set height
                local layer = getglobal(WFCDTvalues[tostring(WFCDTdefault.number)]["2"])
                local height = (WFCDTGraph:GetHeight()-10)/WFCDTdefault.dmgrecord*WFCDTdefault.dmgsum
                layer:SetHeight(height)
                --set color
                local r,g,b,a = barColor()
                layer:SetVertexColor(r,g,b,a)
            end
        end
        WFCDTResizeGraph()
        --DEFAULT_CHAT_FRAME:AddMessage("resize1")   
        
    --create the bars
    elseif (WFCDTdefault.number<WFCDTdefault.maxbars) then
        if (WFCDTvalues[tostring(WFCDTdefault.number+1)]~=nil) then
            if (getglobal(WFCDTvalues[tostring(WFCDTdefault.number+1)]["1"])==nil) then
                WFCDTdefault.number=WFCDTdefault.number+1
                WFCDTvalues[tostring(WFCDTdefault.number)]={["1"]={},["2"]={},["3"]={},}
                WFCDTvalues[tostring(WFCDTdefault.number)]["3"] = WFCDTdefault.dmgsum
                WFCDT:CreateBar()
                WFCDTResizeGraph()
                --DEFAULT_CHAT_FRAME:AddMessage("resize3")    
            elseif (getglobal(WFCDTvalues[tostring(WFCDTdefault.number+1)]["1"])~=nil) then
                WFCDTdefault.number=WFCDTdefault.number+1
                WFCDTvalues[tostring(WFCDTdefault.number)]["3"] = WFCDTdefault.dmgsum
                local anchor = getglobal(WFCDTvalues[tostring(WFCDTdefault.number)]["1"])
                local layer = getglobal(WFCDTvalues[tostring(WFCDTdefault.number)]["2"])
                anchor:Show()
                layer:Show()
                --set color
                local r,g,b,a = barColor()
                layer:SetVertexColor(r,g,b,a)
                WFCDTResizeGraph()    
                --DEFAULT_CHAT_FRAME:AddMessage("resize2")    
            end
        elseif (WFCDTvalues[tostring(WFCDTdefault.number+1)]==nil) then
            WFCDTdefault.number=WFCDTdefault.number+1
            WFCDTvalues[tostring(WFCDTdefault.number)]={["1"]={},["2"]={},["3"]={},}
            WFCDTvalues[tostring(WFCDTdefault.number)]["3"] = WFCDTdefault.dmgsum
            WFCDT:CreateBar()
            WFCDTResizeGraph()
            --DEFAULT_CHAT_FRAME:AddMessage("resize4")    
        end
    end
end

function WFCDTResizeGraph()
    for i=1,WFCDTdefault.number do
        if (WFCDTvalues[tostring(i)]~=nil) then
            local anchor = getglobal(WFCDTvalues[tostring(i)]["1"])
            local layer = getglobal(WFCDTvalues[tostring(i)]["2"])
            local height = (WFCDTGraph:GetHeight()-10)/WFCDTdefault.dmgrecord*WFCDTvalues[tostring(i)]["3"]
            local width = (WFCDTGraph:GetWidth()-10)/WFCDTdefault.number
            --if anchor then
                anchor:SetWidth(width)
                layer:SetWidth(width)
                anchor:SetHeight(height)
                layer:SetHeight(height)
            --end
        end
    end
end

function WFCDTLoadGraph()
    --here we want to create the bar on load
    --[[
    if (WFCDTvalues) then
                DEFAULT_CHAT_FRAME:AddMessage("test"..WFCDTdefault.number)
        for i,v in ipairs(WFCDTvalues) do
            DEFAULT_CHAT_FRAME:AddMessage("test2")
            for i=1,getn(WFCDTvalues) do
                --create frames
                WFCDTCreateGraph()
                    DEFAULT_CHAT_FRAME:AddMessage("WFCDTLoadGraph")
            end
        end
    end
    --]]
end

function WFCDTSimulateGraph()
    --simulate procs and send it to the graph for testing
end